///////////////
// IanniX
///////////////

////////////////////////////
// NxSpline
////////////////////////////

#ifndef	NX_SPLINE_H
#define	NX_SPLINE_H

#include "../../base/atoms/NxTypes.h"

#define DIV_FACTOR 0.2 //adjust this factor to adjust the TrimCurve smoothness

class TrimCurve
{
 public:
  	float Ax,Ay;
  	float Bx,By;
  	float Cx,Cy;
  	float NewX, NewY;
	int Ndiv;
	
	float cMin, cMax ;

  	TrimCurve(float ax,float ay,float bx,float by,float cx,float cy,int ndiv) ;
  	TrimCurve(float ax,float ay,float bx,float by,float cx,float cy );
  	TrimCurve(); 
			
  	// Evaluation & render funcs
  	float max( int f1, int f2 );
	float evalDistance(float x1, float y1, float x2, float y2);
  	void PutCurve( float ax, float ay, float bx, float by, float cx, float cy );
  	void draw( float x, float y, float z ); 
  	int GetCount();
  	void GetCurve( float x, float y, NxPoint NxPoints[], int& NxPointCount);
};

class NxSpline
{
 public:
	float* Px;
  	float* Py;
  	float* Ax;
  	float* Ay;
  	float* Bx;
  	float* By;
  	float* Cx;
  	float* Cy;
  	float* k;
  	float* Mat[3];

  	int NP;
	float splineLength;

	NxPoint pos ; // position of the parent NxCurve*
	float scale ;
	// Data for real-time evaluation
	float actualTime;
	int indexRT;
	int divRT;
	float currentValue; 
	float currentX, currentY;
	float varX, varY;
	float vMin, vMax; // real min & max of curve
	float realMin, realMax; // wanted real & max
	int nbSteps;
	TrimCurve* curveDef;
	TrimCurve seg;
	
  	// Constructor
  	NxSpline( NxPoint inPos, NxPoint pt[], int np, float inMin, float inMax, float inScale );
  	NxSpline( NxPoint inPos, float px[] , float py[] , int np, float inScale ); 
  	~NxSpline();

	float getValue( float inTime );
  	float getInverseValue( float inTime );
	void setRealValues( float inRMin, float inRMax );
	void setRealMin( float inRMin ) ;
	void setRealMax( float inRMax ) ;
	void setScale( float inScale) ;
	void Generate(); 
  	void MatrixSolve(float B[]); 
  	void draw(); 
  	int GetCurveCount();
  	void GetCurve(NxPoint NxPoints[], int& NxPointCount);
	void getTrimCurve();
	TrimCurve* trimCurve();

  	//////////// closed cubic NxSpline ////////////////////
  	void GenClosed(); 
  	void MatrixSolveEX(float B[]); 
  	void drawClosed(); 
	void reset();
};

#endif
