///////////////
// IanniX
///////////////

////////////////////////////
// NxControlCenter
////////////////////////////

#ifndef NxControlCenter_H
#define NxControlCenter_H

#include <QtGui>

// IanniX classes
#include "../graphics/opengl/NxGLScore.h"
#include <math.h>

class NxGLScore;
class NxScore;

class NxControlCenter : public QDialog
{
  Q_OBJECT

 public:
	NxControlCenter( NxGLScore* parent = 0 );
  	~NxControlCenter();

	void addItems();
  	void updateIndexes();
  	void clearTable();
  	void updateItems( int choice, bool add, int inInd );
	void updateParameters( int choice, int inID) ;
	
	QColor backgColor ; // Backg color for the non modifiable values
		
 protected:

 protected slots:
	virtual void updateCurve( int inRow, int inCol );
  	virtual void updateTrajectory( int inRow, int inCol );
	virtual void updateCursor( int inRow, int inCol );
	virtual void updateTrigger( int inRow, int inCol );
	virtual void languageChange();
  	virtual void closeEvent( QCloseEvent* );
	virtual void keyReleaseEvent( QKeyEvent* e );
	virtual void updateCurvesDrawTypes() ; // could be better ...
	virtual void updateCursorsBackward() ; // could be better ...
	virtual void updateCursorsMode() ; // could be better ...
	
 private:
  	QPixmap image0;
  	QPixmap image1;
  	QPixmap image2;
  	QLabel* titleLabel;
  	QLabel* libraryLabel;
  	QFileDialog* fileChooser;
  
  	QTabWidget* controlBox ;
  	QWidget *curvePage, *trajectPage, *triggerPage, *cursorPage;
  	QTableWidget *curveList, *trajectList, *triggerList, *cursorList;
  	QListWidget* library;
  
  	// Main layout
  	QVBoxLayout* mainLayout;
  	QVBoxLayout* boxLayout;
  
  	// Partition pointer
  	NxScore* score;
  	NxGLScore* parentGLBox;
	
  	// Local indexes
  	int nbCurves, nbCursors, nbTrajects, nbTriggers;
};

#endif // NxControlCenter_H

