///////////////
// IanniX
///////////////

////////////////////////////
// NxPainter.cpp
////////////////////////////

#include "NxPainter.h"
#include <stdlib.h>
#include <math.h>

NxPainter::NxPainter( QWidget *parent )
  : QWidget( parent )
{
	//setBackgroundColor( Qt::white ); // white background
	states = NULL;
	nbStates = 0;
}

NxPainter::~NxPainter()
{
}

// States functions
void NxPainter::setStates( State* inStates, int inNbStates )
{
	states = inStates;
	nbStates = inNbStates;
}

// Geometric functions
void NxPainter::drawSinus( int orig, int end, int amp, int freq )
{
	QPainter pt( this );
  	pt.setPen( Qt::blue );
  	double step = ( orig-end ) / freq;
  	for (int i=0;i<end-orig;i++) 
    	pt.drawLine( orig+i, 180+(int) (sin(i*2*PI/step)*amp), orig+i+1, 180+(int) (sin((i+1)*2*PI/step)*amp) );
}

void NxPainter::drawCosinus( int orig, int end, int amp, int freq )
{
	QPainter pt( this );
  	pt.setPen( Qt::blue );
  	double step = ( orig-end ) / freq;
  	for (int i=0;i<end-orig;i++) 
    	pt.drawLine( orig+i, 180+(int) (cos(i*2*PI/step)*amp), orig+i+1, 180+(int) (cos((i+1)*2*PI/step)*amp) );
}

void NxPainter::drawLogarithm( int orig, int end, int amp )
{
	QPainter pt( this );
  	pt.setPen( Qt::blue );
  	for (int i=0;i<end-orig;i++)
    	pt.drawLine( orig+i, 180-(int) ( amp*log(i) ), orig+i+1, 180-(int) ( amp*log(i+1) ) );
}

void NxPainter::paintEvent( QPaintEvent * )
{
	//printf("Paint event \n") ;
	QPainter pt( this );
  	//QFont f( "Helvetica", 8);
  	//pt.setFont( f );
  	
	int len = 580 ; // length of the timeline

	// Timelines, with repears
	pt.setPen( Qt::gray );
  	pt.drawLine( 5, 10, 585, 10 );
  	pt.drawLine( 5, 180, 585, 180 );
  
  	QString stmp;
  	for (int i=0; i<=20;i++)
    {	
		pt.setPen( Qt::black );
		stmp = stmp.setNum(i*0.5);
      	pt.drawLine(5+29*i, 10, 5+29*i, 15);
      	pt.drawText( QRect( 29*i-5, 20, 20, 20 ), Qt::AlignCenter, stmp ); 
    }
  
  	// Focused Object line
  	pt.setPen( Qt::blue );
  
	// Dynamic drawing
	
	if (nbStates > 0)
	{
		int currentPosX = 5;
		int currentPosY = 180;
		int posX = 0;
		int posY = 0;
		
		///////////////////// Draw Time
		for (int i=0; i<nbStates; i++)
		{
			posX = (int) (len * states[i].duration / 10000);
			
			if ( states[i].type == 1 ) {
				posY = (int) (posX * states[i].coeff);
				pt.drawLine( currentPosX, currentPosY, currentPosX+posX, currentPosY - posY );
			}
			
			if ( states[i].type == 0 )
				pt.drawLine( currentPosX, currentPosY, currentPosX+posX, currentPosY );
			
			if ( states[i].type == 2 )
				drawCosinus(currentPosX, currentPosX+posX, (int)states[i].scale, (int)states[i].frequency);
			
			if ( states[i].type == 3 )
				drawSinus(currentPosX, currentPosX+posX, (int)states[i].scale, (int)states[i].frequency);
			
			if ( states[i].type == 4 )
				drawLogarithm( currentPosX, currentPosX+posX, 15);
				
			currentPosX+= posX;
		}	
	}
	  
	pt.setPen( Qt::red );
  	//pt.drawLine(5, 50, 585, 50); 
  	//drawSinus( 50, 120, 50, 5 );
	
	/*
  	// Logarithm curve : amp = 50 
  	orig = 5+58*7;
  	end = 5+58*10;
  	drawLogarithm( orig, end, 15 ); 
	*/
	
}
